   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.2 - 29 Jun 2010
   3                     ; Generator V4.3.5 - 02 Jul 2010
   4                     ; Optimizer V4.3.4.1 - 20 Jul 2010
  48                     ; 46 void DMA_GlobalDeInit(void)
  48                     ; 47 {
  50                     .text:	section	.text,new
  51  0000               _DMA_GlobalDeInit:
  55                     ; 49   DMA1->GCSR &= (uint8_t)~(DMA_GCSR_GE);
  57  0000 72115070      	bres	20592,#0
  58                     ; 51   DMA1->GCSR  = (uint8_t)DMA_GCSR_RESET_VALUE;
  60  0004 35fc5070      	mov	20592,#252
  61                     ; 52 }
  64  0008 81            	ret	
 180                     ; 58 void DMA_DeInit(DMA_Channel_TypeDef* DMA_Channelx)
 180                     ; 59 {
 181                     .text:	section	.text,new
 182  0000               _DMA_DeInit:
 184  0000 89            	pushw	x
 185       00000000      OFST:	set	0
 188                     ; 61   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 190                     ; 63   DMA_Channelx->CCR &= (uint8_t)~(DMA_CCR_CE);
 192  0001 f6            	ld	a,(x)
 193  0002 a4fe          	and	a,#254
 194  0004 f7            	ld	(x),a
 195                     ; 65   DMA_Channelx->CCR  = DMA_CCR_RESET_VALUE;
 197  0005 7f            	clr	(x)
 198                     ; 68   DMA_Channelx->CNBTR = DMA_CNBTR_RESET_VALUE;
 200  0006 6f02          	clr	(2,x)
 201                     ; 71   if (DMA_Channelx == DMA1_Channel3)
 203  0008 a35093        	cpw	x,#20627
 204  000b 2604          	jrne	L501
 205                     ; 73     DMA_Channelx->CPARH  = DMA_C3PARH_RESET_VALUE;
 207  000d a640          	ld	a,#64
 209  000f 2004          	jra	L701
 210  0011               L501:
 211                     ; 77     DMA_Channelx->CPARH  = DMA_CPARH_RESET_VALUE;
 213  0011 1e01          	ldw	x,(OFST+1,sp)
 214  0013 a652          	ld	a,#82
 215  0015               L701:
 216  0015 e703          	ld	(3,x),a
 217                     ; 79   DMA_Channelx->CPARL  = DMA_CPARL_RESET_VALUE;
 219  0017 1e01          	ldw	x,(OFST+1,sp)
 220                     ; 82   DMA_Channelx->CM0ARH = DMA_CM0ARH_RESET_VALUE;
 222  0019 6f06          	clr	(6,x)
 223  001b 6f04          	clr	(4,x)
 224                     ; 83   DMA_Channelx->CM0ARL = DMA_CM0ARL_RESET_VALUE;
 226  001d 6f07          	clr	(7,x)
 227                     ; 85   DMA_Channelx->CSPR = DMA_CSPR_RESET_VALUE;
 229  001f 6f01          	clr	(1,x)
 230                     ; 87 }
 233  0021 85            	popw	x
 234  0022 81            	ret	
 474                     ; 111 void DMA_Init(DMA_Channel_TypeDef* DMA_Channelx,
 474                     ; 112               uint16_t DMA_Memory0BaseAddr,
 474                     ; 113               uint16_t DMA_PeripheralMemory1BaseAddr,
 474                     ; 114               uint8_t DMA_BufferSize,
 474                     ; 115               DMA_DIR_TypeDef DMA_DIR,
 474                     ; 116               DMA_Mode_TypeDef DMA_Mode,
 474                     ; 117               DMA_MemoryIncMode_TypeDef DMA_MemoryIncMode,
 474                     ; 118               DMA_Priority_TypeDef DMA_Priority,
 474                     ; 119               DMA_MemoryDataSize_TypeDef DMA_MemoryDataSize )
 474                     ; 120 {
 475                     .text:	section	.text,new
 476  0000               _DMA_Init:
 478  0000 89            	pushw	x
 479       00000000      OFST:	set	0
 482                     ; 122   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 484                     ; 123   assert_param(IS_DMA_DIR(DMA_DIR));
 486                     ; 124   assert_param(IS_DMA_BUFFER_SIZE(DMA_BufferSize));
 488                     ; 125   assert_param(IS_DMA_MODE(DMA_Mode));
 490                     ; 126   assert_param(IS_DMA_MEMORY_INC_MODE(DMA_MemoryIncMode));
 492                     ; 127   assert_param(IS_DMA_PRIORITY(DMA_Priority));
 494                     ; 132   DMA_Channelx->CCR &= (uint8_t)~(DMA_CCR_CE);
 496  0001 f6            	ld	a,(x)
 497  0002 a4fe          	and	a,#254
 498  0004 f7            	ld	(x),a
 499                     ; 134   DMA_Channelx->CCR  = DMA_CCR_RESET_VALUE;
 501  0005 7f            	clr	(x)
 502                     ; 136   DMA_Channelx->CCR |= (uint8_t)(DMA_DIR | DMA_Mode | DMA_MemoryIncMode);
 504  0006 7b0a          	ld	a,(OFST+10,sp)
 505  0008 1a0b          	or	a,(OFST+11,sp)
 506  000a 1a0c          	or	a,(OFST+12,sp)
 507  000c fa            	or	a,(x)
 508  000d f7            	ld	(x),a
 509                     ; 138   DMA_Channelx->CSPR &= (uint8_t)~(DMA_CSPR_PL | DMA_CSPR_16BM);
 511  000e e601          	ld	a,(1,x)
 512  0010 a4c7          	and	a,#199
 513  0012 e701          	ld	(1,x),a
 514                     ; 140   DMA_Channelx->CSPR |= (uint8_t)(DMA_Priority | DMA_MemoryDataSize);
 516  0014 7b0d          	ld	a,(OFST+13,sp)
 517  0016 1a0e          	or	a,(OFST+14,sp)
 518  0018 ea01          	or	a,(1,x)
 519  001a e701          	ld	(1,x),a
 520                     ; 144   DMA_Channelx->CNBTR = (uint8_t)DMA_BufferSize;
 522  001c 1e01          	ldw	x,(OFST+1,sp)
 523  001e 7b09          	ld	a,(OFST+9,sp)
 524  0020 e702          	ld	(2,x),a
 525                     ; 148   DMA_Channelx->CPARH = (uint8_t)(DMA_PeripheralMemory1BaseAddr >> (uint8_t)8);
 527  0022 7b07          	ld	a,(OFST+7,sp)
 528  0024 e703          	ld	(3,x),a
 529                     ; 149   DMA_Channelx->CPARL = (uint8_t)(DMA_PeripheralMemory1BaseAddr);
 531  0026 7b08          	ld	a,(OFST+8,sp)
 532  0028 e704          	ld	(4,x),a
 533                     ; 152   DMA_Channelx->CM0ARH = (uint8_t)(DMA_Memory0BaseAddr >> (uint8_t)8);
 535  002a 7b05          	ld	a,(OFST+5,sp)
 536  002c e706          	ld	(6,x),a
 537                     ; 153   DMA_Channelx->CM0ARL = (uint8_t)(DMA_Memory0BaseAddr);
 539  002e 7b06          	ld	a,(OFST+6,sp)
 540  0030 e707          	ld	(7,x),a
 541                     ; 154 }
 544  0032 85            	popw	x
 545  0033 81            	ret	
 600                     ; 162 void DMA_GlobalCmd(FunctionalState NewState)
 600                     ; 163 {
 601                     .text:	section	.text,new
 602  0000               _DMA_GlobalCmd:
 606                     ; 165   assert_param(IS_FUNCTIONAL_STATE(NewState));
 608                     ; 166   if (NewState != DISABLE)
 610  0000 4d            	tnz	a
 611  0001 2705          	jreq	L762
 612                     ; 169     DMA1->GCSR |= (uint8_t)DMA_GCSR_GE;
 614  0003 72105070      	bset	20592,#0
 617  0007 81            	ret	
 618  0008               L762:
 619                     ; 174     DMA1->GCSR &= (uint8_t)(~DMA_GCSR_GE);
 621  0008 72115070      	bres	20592,#0
 622                     ; 176 }
 625  000c 81            	ret	
 672                     ; 187 void DMA_Cmd(DMA_Channel_TypeDef* DMA_Channelx, FunctionalState NewState)
 672                     ; 188 {
 673                     .text:	section	.text,new
 674  0000               _DMA_Cmd:
 676  0000 89            	pushw	x
 677       00000000      OFST:	set	0
 680                     ; 190   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 682                     ; 191   assert_param(IS_FUNCTIONAL_STATE(NewState));
 684                     ; 192   if (NewState != DISABLE)
 686  0001 7b05          	ld	a,(OFST+5,sp)
 687  0003 2705          	jreq	L713
 688                     ; 195     DMA_Channelx->CCR |= DMA_CCR_CE;
 690  0005 f6            	ld	a,(x)
 691  0006 aa01          	or	a,#1
 693  0008 2005          	jra	L123
 694  000a               L713:
 695                     ; 200     DMA_Channelx->CCR &= (uint8_t)(~DMA_CCR_CE);
 697  000a 1e01          	ldw	x,(OFST+1,sp)
 698  000c f6            	ld	a,(x)
 699  000d a4fe          	and	a,#254
 700  000f               L123:
 701  000f f7            	ld	(x),a
 702                     ; 202 }
 705  0010 85            	popw	x
 706  0011 81            	ret	
 783                     ; 213 void DMA_ITConfig(DMA_Channel_TypeDef* DMA_Channelx, DMA_ITx_TypeDef DMA_ITx,
 783                     ; 214                   FunctionalState NewState)
 783                     ; 215 {
 784                     .text:	section	.text,new
 785  0000               _DMA_ITConfig:
 787  0000 89            	pushw	x
 788       00000000      OFST:	set	0
 791                     ; 217   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 793                     ; 218   assert_param(IS_DMA_CONFIG_ITX(DMA_ITx));
 795                     ; 219   assert_param(IS_FUNCTIONAL_STATE(NewState));
 797                     ; 220   if (NewState != DISABLE)
 799  0001 7b06          	ld	a,(OFST+6,sp)
 800  0003 2705          	jreq	L363
 801                     ; 223     DMA_Channelx->CCR |= (uint8_t)(DMA_ITx);
 803  0005 f6            	ld	a,(x)
 804  0006 1a05          	or	a,(OFST+5,sp)
 806  0008 2006          	jra	L563
 807  000a               L363:
 808                     ; 228     DMA_Channelx->CCR &= (uint8_t)~(DMA_ITx);
 810  000a 1e01          	ldw	x,(OFST+1,sp)
 811  000c 7b05          	ld	a,(OFST+5,sp)
 812  000e 43            	cpl	a
 813  000f f4            	and	a,(x)
 814  0010               L563:
 815  0010 f7            	ld	(x),a
 816                     ; 230 }
 819  0011 85            	popw	x
 820  0012 81            	ret	
 852                     ; 238 void DMA_SetTimeOut(uint8_t DMA_TimeOut)
 852                     ; 239 {
 853                     .text:	section	.text,new
 854  0000               _DMA_SetTimeOut:
 858                     ; 241   assert_param(IS_DMA_TIMEOUT(DMA_TimeOut));
 860                     ; 243   DMA1->GCSR = 0;
 862  0000 725f5070      	clr	20592
 863                     ; 244   DMA1->GCSR = (uint8_t)(DMA_TimeOut << (uint8_t)2);
 865  0004 48            	sll	a
 866  0005 48            	sll	a
 867  0006 c75070        	ld	20592,a
 868                     ; 245 }
 871  0009 81            	ret	
 909                     ; 252 uint8_t DMA_GetCurrDataCounter(DMA_Channel_TypeDef* DMA_Channelx)
 909                     ; 253 {
 910                     .text:	section	.text,new
 911  0000               _DMA_GetCurrDataCounter:
 915                     ; 255   assert_param(IS_DMA_CHANNEL(DMA_Channelx));
 917                     ; 257   return ((uint8_t)(DMA_Channelx->CNBTR));
 919  0000 e602          	ld	a,(2,x)
 922  0002 81            	ret	
1167                     ; 266 FlagStatus DMA_GetFlagStatus(DMA_FLAG_TypeDef DMA_FLAG)
1167                     ; 267 {
1168                     .text:	section	.text,new
1169  0000               _DMA_GetFlagStatus:
1171  0000 89            	pushw	x
1172  0001 5204          	subw	sp,#4
1173       00000004      OFST:	set	4
1176                     ; 268   FlagStatus bitstatus = RESET;
1178                     ; 269   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1180                     ; 270   uint8_t tmpgir1 = 0;
1182                     ; 271   uint8_t tmpgcsr = 0;
1184                     ; 272   tmpgcsr = DMA1->GCSR;
1186  0003 c65070        	ld	a,20592
1187  0006 6b04          	ld	(OFST+0,sp),a
1188                     ; 273   tmpgir1 = DMA1->GIR1;
1190  0008 c65071        	ld	a,20593
1191  000b 6b01          	ld	(OFST-3,sp),a
1192                     ; 275   assert_param(IS_DMA_GET_FLAG(DMA_FLAG));
1194                     ; 277   if ((DMA_FLAG & (uint16_t)0x0F00) != (uint16_t)RESET)
1196  000d 01            	rrwa	x,a
1197  000e 9f            	ld	a,xl
1198  000f a40f          	and	a,#15
1199  0011 97            	ld	xl,a
1200  0012 4f            	clr	a
1201  0013 02            	rlwa	x,a
1202  0014 5d            	tnzw	x
1203  0015 2728          	jreq	L545
1204                     ; 280     if ((DMA_FLAG & 0x0100) != (uint16_t)RESET)       DMA_Channelx = DMA1_Channel0;
1206  0017 7b05          	ld	a,(OFST+1,sp)
1207  0019 a501          	bcp	a,#1
1208  001b 2705          	jreq	L745
1211  001d ae5075        	ldw	x,#20597
1213  0020 2015          	jra	L155
1214  0022               L745:
1215                     ; 281     else if  ((DMA_FLAG & 0x0200) != (uint16_t)RESET) DMA_Channelx = DMA1_Channel1;
1217  0022 a502          	bcp	a,#2
1218  0024 2705          	jreq	L355
1221  0026 ae507f        	ldw	x,#20607
1223  0029 200c          	jra	L155
1224  002b               L355:
1225                     ; 282     else if  ((DMA_FLAG & 0x0400) != (uint16_t)RESET) DMA_Channelx = DMA1_Channel2;
1227  002b a504          	bcp	a,#4
1228  002d 2705          	jreq	L755
1231  002f ae5089        	ldw	x,#20617
1233  0032 2003          	jra	L155
1234  0034               L755:
1235                     ; 283     else                                         DMA_Channelx = DMA1_Channel3;
1237  0034 ae5093        	ldw	x,#20627
1238  0037               L155:
1239  0037 1f02          	ldw	(OFST-2,sp),x
1240                     ; 285     bitstatus = (uint8_t)(DMA_Channelx->CSPR & (uint8_t)DMA_FLAG);
1242  0039 e601          	ld	a,(1,x)
1243  003b 1406          	and	a,(OFST+2,sp)
1245  003d 2010          	jra	L365
1246  003f               L545:
1247                     ; 287   else if ((DMA_FLAG & 0x1000) != (uint16_t)RESET)
1249  003f 7b05          	ld	a,(OFST+1,sp)
1250  0041 a510          	bcp	a,#16
1251  0043 2706          	jreq	L565
1252                     ; 289     bitstatus = (FlagStatus)(tmpgir1 & (uint8_t)DMA_FLAG);
1254  0045 7b06          	ld	a,(OFST+2,sp)
1255  0047 1401          	and	a,(OFST-3,sp)
1257  0049 2004          	jra	L365
1258  004b               L565:
1259                     ; 293     bitstatus = (FlagStatus)(tmpgcsr & DMA_GCSR_GB);
1261  004b 7b04          	ld	a,(OFST+0,sp)
1262  004d a402          	and	a,#2
1263  004f               L365:
1264                     ; 296   return (bitstatus);
1268  004f 5b06          	addw	sp,#6
1269  0051 81            	ret	
1316                     ; 306 void DMA_ClearFlag(DMA_FLAG_TypeDef DMA_FLAG)
1316                     ; 307 {
1317                     .text:	section	.text,new
1318  0000               _DMA_ClearFlag:
1320  0000 89            	pushw	x
1321  0001 89            	pushw	x
1322       00000002      OFST:	set	2
1325                     ; 308   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1327                     ; 311   assert_param(IS_DMA_CLEAR_FLAG(DMA_FLAG));
1329                     ; 313   if      ((DMA_FLAG & 0x0100) != (uint16_t)RESET)   DMA_Channelx = DMA1_Channel0;
1331  0002 01            	rrwa	x,a
1332  0003 9f            	ld	a,xl
1333  0004 a401          	and	a,#1
1334  0006 97            	ld	xl,a
1335  0007 4f            	clr	a
1336  0008 02            	rlwa	x,a
1337  0009 5d            	tnzw	x
1338  000a 2705          	jreq	L516
1341  000c ae5075        	ldw	x,#20597
1343  000f 2017          	jra	L716
1344  0011               L516:
1345                     ; 314   else if ((DMA_FLAG & 0x0200) != (uint16_t)RESET)   DMA_Channelx = DMA1_Channel1;
1347  0011 7b03          	ld	a,(OFST+1,sp)
1348  0013 a502          	bcp	a,#2
1349  0015 2705          	jreq	L126
1352  0017 ae507f        	ldw	x,#20607
1354  001a 200c          	jra	L716
1355  001c               L126:
1356                     ; 315   else if ((DMA_FLAG & 0x0400) != (uint16_t)RESET)   DMA_Channelx = DMA1_Channel2;
1358  001c a504          	bcp	a,#4
1359  001e 2705          	jreq	L526
1362  0020 ae5089        	ldw	x,#20617
1364  0023 2003          	jra	L716
1365  0025               L526:
1366                     ; 316   else                                          DMA_Channelx = DMA1_Channel3;
1368  0025 ae5093        	ldw	x,#20627
1369  0028               L716:
1370  0028 1f01          	ldw	(OFST-1,sp),x
1371                     ; 318   DMA_Channelx->CSPR &= (uint8_t)~((uint8_t)DMA_FLAG & 0x06);
1373  002a 7b04          	ld	a,(OFST+2,sp)
1374  002c a406          	and	a,#6
1375  002e 43            	cpl	a
1376  002f e401          	and	a,(1,x)
1377  0031 e701          	ld	(1,x),a
1378                     ; 319 }
1381  0033 5b04          	addw	sp,#4
1382  0035 81            	ret	
1502                     ; 328 ITStatus DMA_GetITStatus(DMA_IT_TypeDef DMA_IT)
1502                     ; 329 {
1503                     .text:	section	.text,new
1504  0000               _DMA_GetITStatus:
1506  0000 88            	push	a
1507  0001 5203          	subw	sp,#3
1508       00000003      OFST:	set	3
1511                     ; 330   ITStatus bitstatus = RESET;
1513                     ; 331   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1515                     ; 334   assert_param(IS_DMA_GET_IT(DMA_IT));
1517                     ; 336   if ((DMA_IT & 0x10) != (uint8_t)RESET)         DMA_Channelx = DMA1_Channel0;
1519  0003 a510          	bcp	a,#16
1520  0005 2705          	jreq	L507
1523  0007 ae5075        	ldw	x,#20597
1525  000a 2017          	jra	L707
1526  000c               L507:
1527                     ; 337   else if  ((DMA_IT & 0x20) != (uint8_t)RESET)   DMA_Channelx = DMA1_Channel1;
1529  000c 7b04          	ld	a,(OFST+1,sp)
1530  000e a520          	bcp	a,#32
1531  0010 2705          	jreq	L117
1534  0012 ae507f        	ldw	x,#20607
1536  0015 200c          	jra	L707
1537  0017               L117:
1538                     ; 338   else if  ((DMA_IT & 0x40) != (uint8_t)RESET)   DMA_Channelx = DMA1_Channel2;
1540  0017 a540          	bcp	a,#64
1541  0019 2705          	jreq	L517
1544  001b ae5089        	ldw	x,#20617
1546  001e 2003          	jra	L707
1547  0020               L517:
1548                     ; 339   else                                      DMA_Channelx = DMA1_Channel3;
1550  0020 ae5093        	ldw	x,#20627
1551  0023               L707:
1552  0023 1f02          	ldw	(OFST-1,sp),x
1553                     ; 341   bitstatus = (ITStatus)(DMA_Channelx->CCR & DMA_Channelx->CSPR & (DMA_CCR_TCIE | DMA_CCR_HTIE) & DMA_IT);
1555  0025 e601          	ld	a,(1,x)
1556  0027 f4            	and	a,(x)
1557  0028 a406          	and	a,#6
1558  002a 1404          	and	a,(OFST+1,sp)
1559                     ; 344   return (bitstatus);
1563  002c 5b04          	addw	sp,#4
1564  002e 81            	ret	
1612                     ; 355 void DMA_ClearITPendingBit(DMA_IT_TypeDef DMA_IT)
1612                     ; 356 {
1613                     .text:	section	.text,new
1614  0000               _DMA_ClearITPendingBit:
1616  0000 88            	push	a
1617  0001 89            	pushw	x
1618       00000002      OFST:	set	2
1621                     ; 357   DMA_Channel_TypeDef* DMA_Channelx =  DMA1_Channel0;
1623                     ; 360   assert_param(IS_DMA_CLEAR_IT(DMA_IT));
1625                     ; 362   if      ((DMA_IT & 0x10) != (uint8_t)RESET)   DMA_Channelx = DMA1_Channel0;
1627  0002 a510          	bcp	a,#16
1628  0004 2705          	jreq	L547
1631  0006 ae5075        	ldw	x,#20597
1633  0009 2017          	jra	L747
1634  000b               L547:
1635                     ; 363   else if ((DMA_IT & 0x20) != (uint8_t)RESET)   DMA_Channelx = DMA1_Channel1;
1637  000b 7b03          	ld	a,(OFST+1,sp)
1638  000d a520          	bcp	a,#32
1639  000f 2705          	jreq	L157
1642  0011 ae507f        	ldw	x,#20607
1644  0014 200c          	jra	L747
1645  0016               L157:
1646                     ; 364   else if ((DMA_IT & 0x40) != (uint8_t)RESET)   DMA_Channelx = DMA1_Channel2;
1648  0016 a540          	bcp	a,#64
1649  0018 2705          	jreq	L557
1652  001a ae5089        	ldw	x,#20617
1654  001d 2003          	jra	L747
1655  001f               L557:
1656                     ; 365   else                                     DMA_Channelx = DMA1_Channel3;
1658  001f ae5093        	ldw	x,#20627
1659  0022               L747:
1660  0022 1f01          	ldw	(OFST-1,sp),x
1661                     ; 367   DMA_Channelx->CSPR &= (uint8_t)~(DMA_IT & 0x06);
1663  0024 7b03          	ld	a,(OFST+1,sp)
1664  0026 a406          	and	a,#6
1665  0028 43            	cpl	a
1666  0029 e401          	and	a,(1,x)
1667  002b e701          	ld	(1,x),a
1668                     ; 368 }
1671  002d 5b03          	addw	sp,#3
1672  002f 81            	ret	
1685                     	xdef	_DMA_ClearITPendingBit
1686                     	xdef	_DMA_GetITStatus
1687                     	xdef	_DMA_ClearFlag
1688                     	xdef	_DMA_GetFlagStatus
1689                     	xdef	_DMA_GetCurrDataCounter
1690                     	xdef	_DMA_SetTimeOut
1691                     	xdef	_DMA_ITConfig
1692                     	xdef	_DMA_Cmd
1693                     	xdef	_DMA_GlobalCmd
1694                     	xdef	_DMA_Init
1695                     	xdef	_DMA_DeInit
1696                     	xdef	_DMA_GlobalDeInit
1715                     	end
