   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.2 - 29 Jun 2010
   3                     ; Generator V4.3.5 - 02 Jul 2010
   4                     ; Optimizer V4.3.4.1 - 20 Jul 2010
 114                     ; 45 void GPIO_DeInit(GPIO_TypeDef* GPIOx)
 114                     ; 46 {
 116                     .text:	section	.text,new
 117  0000               _GPIO_DeInit:
 121                     ; 47   GPIOx->ODR = GPIO_ODR_RESET_VALUE; /* Reset Output Data Register */
 123  0000 7f            	clr	(x)
 124                     ; 48   GPIOx->DDR = GPIO_DDR_RESET_VALUE; /* Reset Data Direction Register */
 126  0001 6f02          	clr	(2,x)
 127                     ; 49   GPIOx->CR1 = GPIO_CR1_RESET_VALUE; /* Reset Control Register 1 */
 129  0003 6f03          	clr	(3,x)
 130                     ; 50   GPIOx->CR2 = GPIO_CR2_RESET_VALUE; /* Reset Control Register 2 */
 132  0005 6f04          	clr	(4,x)
 133                     ; 51 }
 136  0007 81            	ret	
 290                     ; 62 void GPIO_Init(GPIO_TypeDef* GPIOx,
 290                     ; 63                uint8_t GPIO_Pin,
 290                     ; 64                GPIO_Mode_TypeDef GPIO_Mode)
 290                     ; 65 {
 291                     .text:	section	.text,new
 292  0000               _GPIO_Init:
 294  0000 89            	pushw	x
 295       00000000      OFST:	set	0
 298                     ; 70   assert_param(IS_GPIO_MODE(GPIO_Mode));
 300                     ; 71   assert_param(IS_GPIO_PIN(GPIO_Pin));
 302                     ; 77   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x80) != (uint8_t)0x00) /* Output mode */
 304  0001 7b06          	ld	a,(OFST+6,sp)
 305  0003 2a18          	jrpl	L341
 306                     ; 79     if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x10) != (uint8_t)0x00) /* High level */
 308  0005 a510          	bcp	a,#16
 309  0007 2705          	jreq	L541
 310                     ; 81       GPIOx->ODR |= GPIO_Pin;
 312  0009 f6            	ld	a,(x)
 313  000a 1a05          	or	a,(OFST+5,sp)
 315  000c 2006          	jra	L741
 316  000e               L541:
 317                     ; 84       GPIOx->ODR &= (uint8_t)(~(GPIO_Pin));
 319  000e 1e01          	ldw	x,(OFST+1,sp)
 320  0010 7b05          	ld	a,(OFST+5,sp)
 321  0012 43            	cpl	a
 322  0013 f4            	and	a,(x)
 323  0014               L741:
 324  0014 f7            	ld	(x),a
 325                     ; 87     GPIOx->DDR |= GPIO_Pin;
 327  0015 1e01          	ldw	x,(OFST+1,sp)
 328  0017 e602          	ld	a,(2,x)
 329  0019 1a05          	or	a,(OFST+5,sp)
 331  001b 2007          	jra	L151
 332  001d               L341:
 333                     ; 91     GPIOx->DDR &= (uint8_t)(~(GPIO_Pin));
 335  001d 1e01          	ldw	x,(OFST+1,sp)
 336  001f 7b05          	ld	a,(OFST+5,sp)
 337  0021 43            	cpl	a
 338  0022 e402          	and	a,(2,x)
 339  0024               L151:
 340  0024 e702          	ld	(2,x),a
 341                     ; 98   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x40) != (uint8_t)0x00) /* Pull-Up or Push-Pull */
 343  0026 7b06          	ld	a,(OFST+6,sp)
 344  0028 a540          	bcp	a,#64
 345  002a 2706          	jreq	L351
 346                     ; 100     GPIOx->CR1 |= GPIO_Pin;
 348  002c e603          	ld	a,(3,x)
 349  002e 1a05          	or	a,(OFST+5,sp)
 351  0030 2005          	jra	L551
 352  0032               L351:
 353                     ; 103     GPIOx->CR1 &= (uint8_t)(~(GPIO_Pin));
 355  0032 7b05          	ld	a,(OFST+5,sp)
 356  0034 43            	cpl	a
 357  0035 e403          	and	a,(3,x)
 358  0037               L551:
 359  0037 e703          	ld	(3,x),a
 360                     ; 110   if ((((uint8_t)(GPIO_Mode)) & (uint8_t)0x20) != (uint8_t)0x00) /* Interrupt or Slow slope */
 362  0039 7b06          	ld	a,(OFST+6,sp)
 363  003b a520          	bcp	a,#32
 364  003d 2706          	jreq	L751
 365                     ; 112     GPIOx->CR2 |= GPIO_Pin;
 367  003f e604          	ld	a,(4,x)
 368  0041 1a05          	or	a,(OFST+5,sp)
 370  0043 2005          	jra	L161
 371  0045               L751:
 372                     ; 115     GPIOx->CR2 &= (uint8_t)(~(GPIO_Pin));
 374  0045 7b05          	ld	a,(OFST+5,sp)
 375  0047 43            	cpl	a
 376  0048 e404          	and	a,(4,x)
 377  004a               L161:
 378  004a e704          	ld	(4,x),a
 379                     ; 118 }
 382  004c 85            	popw	x
 383  004d 81            	ret	
 427                     ; 129 void GPIO_Write(GPIO_TypeDef* GPIOx, uint8_t GPIO_PortVal)
 427                     ; 130 {
 428                     .text:	section	.text,new
 429  0000               _GPIO_Write:
 431  0000 89            	pushw	x
 432       00000000      OFST:	set	0
 435                     ; 131   GPIOx->ODR = GPIO_PortVal;
 437  0001 1e01          	ldw	x,(OFST+1,sp)
 438  0003 7b05          	ld	a,(OFST+5,sp)
 439  0005 f7            	ld	(x),a
 440                     ; 132 }
 443  0006 85            	popw	x
 444  0007 81            	ret	
 604                     ; 143 void GPIO_WriteBit(GPIO_TypeDef* GPIOx, GPIO_Pin_TypeDef GPIO_Pin, BitAction GPIO_BitVal)
 604                     ; 144 {
 605                     .text:	section	.text,new
 606  0000               _GPIO_WriteBit:
 608  0000 89            	pushw	x
 609       00000000      OFST:	set	0
 612                     ; 146   assert_param(IS_GPIO_PIN(GPIO_Pin));
 614                     ; 147   assert_param(IS_STATE_VALUE(GPIO_BitVal));
 616                     ; 149   if (GPIO_BitVal != RESET)
 618  0001 7b06          	ld	a,(OFST+6,sp)
 619  0003 2714          	jreq	L772
 620                     ; 151     SetBit(GPIOx->ODR, GPIO_Pin);
 622  0005 7b05          	ld	a,(OFST+5,sp)
 623  0007 905f          	clrw	y
 624  0009 9097          	ld	yl,a
 625  000b a601          	ld	a,#1
 626  000d 905d          	tnzw	y
 627  000f 2705          	jreq	L41
 628  0011               L61:
 629  0011 48            	sll	a
 630  0012 905a          	decw	y
 631  0014 26fb          	jrne	L61
 632  0016               L41:
 633  0016 fa            	or	a,(x)
 635  0017 2015          	jra	L103
 636  0019               L772:
 637                     ; 156     ClrBit(GPIOx->ODR, GPIO_Pin);
 639  0019 1e01          	ldw	x,(OFST+1,sp)
 640  001b 7b05          	ld	a,(OFST+5,sp)
 641  001d 905f          	clrw	y
 642  001f 9097          	ld	yl,a
 643  0021 a601          	ld	a,#1
 644  0023 905d          	tnzw	y
 645  0025 2705          	jreq	L02
 646  0027               L22:
 647  0027 48            	sll	a
 648  0028 905a          	decw	y
 649  002a 26fb          	jrne	L22
 650  002c               L02:
 651  002c 43            	cpl	a
 652  002d f4            	and	a,(x)
 653  002e               L103:
 654  002e f7            	ld	(x),a
 655                     ; 158 }
 658  002f 85            	popw	x
 659  0030 81            	ret	
 703                     ; 168 void GPIO_SetBits(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin)
 703                     ; 169 {
 704                     .text:	section	.text,new
 705  0000               _GPIO_SetBits:
 707  0000 89            	pushw	x
 708       00000000      OFST:	set	0
 711                     ; 170   GPIOx->ODR |= GPIO_Pin;
 713  0001 f6            	ld	a,(x)
 714  0002 1a05          	or	a,(OFST+5,sp)
 715  0004 f7            	ld	(x),a
 716                     ; 171 }
 719  0005 85            	popw	x
 720  0006 81            	ret	
 764                     ; 181 void GPIO_ResetBits(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin)
 764                     ; 182 {
 765                     .text:	section	.text,new
 766  0000               _GPIO_ResetBits:
 768  0000 89            	pushw	x
 769       00000000      OFST:	set	0
 772                     ; 183   GPIOx->ODR &= (uint8_t)(~GPIO_Pin);
 774  0001 7b05          	ld	a,(OFST+5,sp)
 775  0003 43            	cpl	a
 776  0004 f4            	and	a,(x)
 777  0005 f7            	ld	(x),a
 778                     ; 184 }
 781  0006 85            	popw	x
 782  0007 81            	ret	
 826                     ; 194 void GPIO_ToggleBits(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin)
 826                     ; 195 {
 827                     .text:	section	.text,new
 828  0000               _GPIO_ToggleBits:
 830  0000 89            	pushw	x
 831       00000000      OFST:	set	0
 834                     ; 196   GPIOx->ODR ^= GPIO_Pin;
 836  0001 f6            	ld	a,(x)
 837  0002 1805          	xor	a,(OFST+5,sp)
 838  0004 f7            	ld	(x),a
 839                     ; 197 }
 842  0005 85            	popw	x
 843  0006 81            	ret	
 880                     ; 206 uint8_t GPIO_ReadInputData(GPIO_TypeDef* GPIOx)
 880                     ; 207 {
 881                     .text:	section	.text,new
 882  0000               _GPIO_ReadInputData:
 886                     ; 208   return ((uint8_t)GPIOx->IDR);
 888  0000 e601          	ld	a,(1,x)
 891  0002 81            	ret	
 929                     ; 218 uint8_t GPIO_ReadOutputData(GPIO_TypeDef* GPIOx)
 929                     ; 219 {
 930                     .text:	section	.text,new
 931  0000               _GPIO_ReadOutputData:
 935                     ; 220   return ((uint8_t)GPIOx->ODR);
 937  0000 f6            	ld	a,(x)
 940  0001 81            	ret	
 989                     ; 229 BitStatus GPIO_ReadInputDataBit(GPIO_TypeDef* GPIOx, GPIO_Pin_TypeDef GPIO_Pin)
 989                     ; 230 {
 990                     .text:	section	.text,new
 991  0000               _GPIO_ReadInputDataBit:
 993  0000 89            	pushw	x
 994       00000000      OFST:	set	0
 997                     ; 231   return ((BitStatus)(GPIOx->IDR & (uint8_t)GPIO_Pin));
 999  0001 e601          	ld	a,(1,x)
1000  0003 1405          	and	a,(OFST+5,sp)
1003  0005 85            	popw	x
1004  0006 81            	ret	
1053                     ; 240 BitStatus GPIO_ReadOutputDataBit(GPIO_TypeDef* GPIOx, GPIO_Pin_TypeDef GPIO_Pin)
1053                     ; 241 {
1054                     .text:	section	.text,new
1055  0000               _GPIO_ReadOutputDataBit:
1057  0000 89            	pushw	x
1058       00000000      OFST:	set	0
1061                     ; 242   return ((BitStatus)(GPIOx->ODR & (uint8_t)GPIO_Pin));
1063  0001 f6            	ld	a,(x)
1064  0002 1405          	and	a,(OFST+5,sp)
1067  0004 85            	popw	x
1068  0005 81            	ret	
1143                     ; 252 void GPIO_ExternalPullUpConfig(GPIO_TypeDef* GPIOx, uint8_t GPIO_Pin, FunctionalState NewState)
1143                     ; 253 {
1144                     .text:	section	.text,new
1145  0000               _GPIO_ExternalPullUpConfig:
1147  0000 89            	pushw	x
1148       00000000      OFST:	set	0
1151                     ; 255   assert_param(IS_GPIO_PIN(GPIO_Pin));
1153                     ; 256   assert_param(IS_FUNCTIONAL_STATE(NewState));
1155                     ; 258   if (NewState != DISABLE) /* External Pull-Up Set*/
1157  0001 7b06          	ld	a,(OFST+6,sp)
1158  0003 2706          	jreq	L735
1159                     ; 260     GPIOx->CR1 |= GPIO_Pin;
1161  0005 e603          	ld	a,(3,x)
1162  0007 1a05          	or	a,(OFST+5,sp)
1164  0009 2007          	jra	L145
1165  000b               L735:
1166                     ; 263     GPIOx->CR1 &= (uint8_t)(~(GPIO_Pin));
1168  000b 1e01          	ldw	x,(OFST+1,sp)
1169  000d 7b05          	ld	a,(OFST+5,sp)
1170  000f 43            	cpl	a
1171  0010 e403          	and	a,(3,x)
1172  0012               L145:
1173  0012 e703          	ld	(3,x),a
1174                     ; 265 }
1177  0014 85            	popw	x
1178  0015 81            	ret	
1191                     	xdef	_GPIO_ExternalPullUpConfig
1192                     	xdef	_GPIO_ReadOutputDataBit
1193                     	xdef	_GPIO_ReadInputDataBit
1194                     	xdef	_GPIO_ReadOutputData
1195                     	xdef	_GPIO_ReadInputData
1196                     	xdef	_GPIO_ToggleBits
1197                     	xdef	_GPIO_ResetBits
1198                     	xdef	_GPIO_SetBits
1199                     	xdef	_GPIO_WriteBit
1200                     	xdef	_GPIO_Write
1201                     	xdef	_GPIO_Init
1202                     	xdef	_GPIO_DeInit
1221                     	end
