   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.9.2 - 29 Jun 2010
   3                     ; Generator V4.3.5 - 02 Jul 2010
   4                     ; Optimizer V4.3.4.1 - 20 Jul 2010
 141                     ; 45 void SPI_DeInit(SPI_TypeDef* SPIx)
 141                     ; 46 {
 143                     .text:	section	.text,new
 144  0000               _SPI_DeInit:
 148                     ; 47   SPIx->CR1    = SPI_CR1_RESET_VALUE;
 150  0000 7f            	clr	(x)
 151                     ; 48   SPIx->CR2    = SPI_CR2_RESET_VALUE;
 153  0001 6f01          	clr	(1,x)
 154                     ; 49   SPIx->CR3    = SPI_CR3_RESET_VALUE;
 156  0003 6f02          	clr	(2,x)
 157                     ; 50   SPIx->SR     = SPI_SR_RESET_VALUE;
 159  0005 a602          	ld	a,#2
 160  0007 e703          	ld	(3,x),a
 161                     ; 51   SPIx->CRCPR  = SPI_CRCPR_RESET_VALUE;
 163  0009 a607          	ld	a,#7
 164  000b e705          	ld	(5,x),a
 165                     ; 52 }
 168  000d 81            	ret	
 492                     ; 67 void SPI_Init(SPI_TypeDef* SPIx, SPI_FirstBit_TypeDef SPI_FirstBit,
 492                     ; 68               SPI_BaudRatePrescaler_TypeDef SPI_BaudRatePrescaler,
 492                     ; 69               SPI_Mode_TypeDef SPI_Mode, SPI_CPOL_TypeDef SPI_CPOL,
 492                     ; 70               SPI_CPHA_TypeDef SPI_CPHA, SPI_DirectionMode_TypeDef SPI_Data_Direction,
 492                     ; 71               SPI_NSS_TypeDef SPI_Slave_Management, uint8_t CRCPolynomial)
 492                     ; 72 {
 493                     .text:	section	.text,new
 494  0000               _SPI_Init:
 496  0000 89            	pushw	x
 497       00000000      OFST:	set	0
 500                     ; 74   assert_param(IS_SPI_FIRSTBIT(SPI_FirstBit));
 502                     ; 75   assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
 504                     ; 76   assert_param(IS_SPI_MODE(SPI_Mode));
 506                     ; 77   assert_param(IS_SPI_POLARITY(SPI_CPOL));
 508                     ; 78   assert_param(IS_SPI_PHASE(SPI_CPHA));
 510                     ; 79   assert_param(IS_SPI_DATA_DIRECTION(SPI_Data_Direction));
 512                     ; 80   assert_param(IS_SPI_SLAVEMANAGEMENT(SPI_Slave_Management));
 514                     ; 81   assert_param(IS_SPI_CRC_POLYNOMIAL(CRCPolynomial));
 516                     ; 84   SPIx->CR1 = (uint8_t)((uint8_t)(SPI_FirstBit) |
 516                     ; 85                         (uint8_t)(SPI_BaudRatePrescaler) |
 516                     ; 86                         (uint8_t)(SPI_CPOL) |
 516                     ; 87                         (uint8_t)(SPI_CPHA));
 518  0001 7b05          	ld	a,(OFST+5,sp)
 519  0003 1a06          	or	a,(OFST+6,sp)
 520  0005 1a08          	or	a,(OFST+8,sp)
 521  0007 1e01          	ldw	x,(OFST+1,sp)
 522  0009 1a09          	or	a,(OFST+9,sp)
 523  000b f7            	ld	(x),a
 524                     ; 90   SPIx->CR2 = (uint8_t)((uint8_t)(SPI_Data_Direction) | (uint8_t)(SPI_Slave_Management));
 526  000c 7b0a          	ld	a,(OFST+10,sp)
 527  000e 1a0b          	or	a,(OFST+11,sp)
 528  0010 e701          	ld	(1,x),a
 529                     ; 92   if (SPI_Mode == SPI_Mode_Master)
 531  0012 7b07          	ld	a,(OFST+7,sp)
 532  0014 a104          	cp	a,#4
 533  0016 2606          	jrne	L362
 534                     ; 94     SPIx->CR2 |= (uint8_t)SPI_CR2_SSI;
 536  0018 e601          	ld	a,(1,x)
 537  001a aa01          	or	a,#1
 539  001c 2004          	jra	L562
 540  001e               L362:
 541                     ; 98     SPIx->CR2 &= (uint8_t)~(SPI_CR2_SSI);
 543  001e e601          	ld	a,(1,x)
 544  0020 a4fe          	and	a,#254
 545  0022               L562:
 546  0022 e701          	ld	(1,x),a
 547                     ; 102   SPIx->CR1 |= (uint8_t)(SPI_Mode);
 549  0024 f6            	ld	a,(x)
 550  0025 1a07          	or	a,(OFST+7,sp)
 551  0027 f7            	ld	(x),a
 552                     ; 105   SPIx->CRCPR = (uint8_t)CRCPolynomial;
 554  0028 7b0c          	ld	a,(OFST+12,sp)
 555  002a e705          	ld	(5,x),a
 556                     ; 106 }
 559  002c 85            	popw	x
 560  002d 81            	ret	
 627                     ; 115 void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState)
 627                     ; 116 {
 628                     .text:	section	.text,new
 629  0000               _SPI_Cmd:
 631  0000 89            	pushw	x
 632       00000000      OFST:	set	0
 635                     ; 118   assert_param(IS_FUNCTIONAL_STATE(NewState));
 637                     ; 120   if (NewState != DISABLE)
 639  0001 7b05          	ld	a,(OFST+5,sp)
 640  0003 2705          	jreq	L323
 641                     ; 122     SPIx->CR1 |= SPI_CR1_SPE; /* Enable the SPI peripheral*/
 643  0005 f6            	ld	a,(x)
 644  0006 aa40          	or	a,#64
 646  0008 2005          	jra	L523
 647  000a               L323:
 648                     ; 126     SPIx->CR1 &= (uint8_t)(~SPI_CR1_SPE); /* Disable the SPI peripheral*/
 650  000a 1e01          	ldw	x,(OFST+1,sp)
 651  000c f6            	ld	a,(x)
 652  000d a4bf          	and	a,#191
 653  000f               L523:
 654  000f f7            	ld	(x),a
 655                     ; 128 }
 658  0010 85            	popw	x
 659  0011 81            	ret	
 778                     ; 138 void SPI_ITConfig(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT, FunctionalState NewState)
 778                     ; 139 {
 779                     .text:	section	.text,new
 780  0000               _SPI_ITConfig:
 782  0000 89            	pushw	x
 783  0001 88            	push	a
 784       00000001      OFST:	set	1
 787                     ; 140   uint8_t itpos = 0;
 789                     ; 142   assert_param(IS_SPI_CONFIG_IT(SPI_IT));
 791                     ; 143   assert_param(IS_FUNCTIONAL_STATE(NewState));
 793                     ; 146   itpos = (uint8_t)((uint8_t)1 << (uint8_t)((uint8_t)SPI_IT & (uint8_t)0x0F));
 795  0002 7b06          	ld	a,(OFST+5,sp)
 796  0004 a40f          	and	a,#15
 797  0006 5f            	clrw	x
 798  0007 97            	ld	xl,a
 799  0008 a601          	ld	a,#1
 800  000a 5d            	tnzw	x
 801  000b 2704          	jreq	L41
 802  000d               L61:
 803  000d 48            	sll	a
 804  000e 5a            	decw	x
 805  000f 26fc          	jrne	L61
 806  0011               L41:
 807  0011 6b01          	ld	(OFST+0,sp),a
 808                     ; 148   if (NewState != DISABLE)
 810  0013 0d07          	tnz	(OFST+6,sp)
 811  0015 2708          	jreq	L304
 812                     ; 150     SPIx->CR3 |= itpos; /* Enable interrupt*/
 814  0017 1e02          	ldw	x,(OFST+1,sp)
 815  0019 e602          	ld	a,(2,x)
 816  001b 1a01          	or	a,(OFST+0,sp)
 818  001d 2005          	jra	L504
 819  001f               L304:
 820                     ; 154     SPIx->CR3 &= (uint8_t)(~itpos); /* Disable interrupt*/
 822  001f 1e02          	ldw	x,(OFST+1,sp)
 823  0021 43            	cpl	a
 824  0022 e402          	and	a,(2,x)
 825  0024               L504:
 826  0024 e702          	ld	(2,x),a
 827                     ; 156 }
 830  0026 5b03          	addw	sp,#3
 831  0028 81            	ret	
 875                     ; 163 void SPI_SendData(SPI_TypeDef* SPIx, uint8_t Data)
 875                     ; 164 {
 876                     .text:	section	.text,new
 877  0000               _SPI_SendData:
 879  0000 89            	pushw	x
 880       00000000      OFST:	set	0
 883                     ; 165   SPIx->DR = Data; /* Write in the DR register the data to be sent*/
 885  0001 1e01          	ldw	x,(OFST+1,sp)
 886  0003 7b05          	ld	a,(OFST+5,sp)
 887  0005 e704          	ld	(4,x),a
 888                     ; 166 }
 891  0007 85            	popw	x
 892  0008 81            	ret	
 929                     ; 174 uint8_t SPI_ReceiveData(SPI_TypeDef* SPIx)
 929                     ; 175 {
 930                     .text:	section	.text,new
 931  0000               _SPI_ReceiveData:
 935                     ; 176   return ((uint8_t)SPIx->DR); /* Return the data in the DR register*/
 937  0000 e604          	ld	a,(4,x)
 940  0002 81            	ret	
 988                     ; 186 void SPI_NSSInternalSoftwareCmd(SPI_TypeDef* SPIx, FunctionalState NewState)
 988                     ; 187 {
 989                     .text:	section	.text,new
 990  0000               _SPI_NSSInternalSoftwareCmd:
 992  0000 89            	pushw	x
 993       00000000      OFST:	set	0
 996                     ; 189   assert_param(IS_FUNCTIONAL_STATE(NewState));
 998                     ; 191   if (NewState != DISABLE)
1000  0001 7b05          	ld	a,(OFST+5,sp)
1001  0003 2706          	jreq	L574
1002                     ; 193     SPIx->CR2 |= SPI_CR2_SSI; /* Set NSS pin internally by software*/
1004  0005 e601          	ld	a,(1,x)
1005  0007 aa01          	or	a,#1
1007  0009 2006          	jra	L774
1008  000b               L574:
1009                     ; 197     SPIx->CR2 &= (uint8_t)(~SPI_CR2_SSI); /* Reset NSS pin internally by software*/
1011  000b 1e01          	ldw	x,(OFST+1,sp)
1012  000d e601          	ld	a,(1,x)
1013  000f a4fe          	and	a,#254
1014  0011               L774:
1015  0011 e701          	ld	(1,x),a
1016                     ; 199 }
1019  0013 85            	popw	x
1020  0014 81            	ret	
1057                     ; 207 void SPI_TransmitCRC(SPI_TypeDef* SPIx)
1057                     ; 208 {
1058                     .text:	section	.text,new
1059  0000               _SPI_TransmitCRC:
1063                     ; 209   SPIx->CR2 |= SPI_CR2_CRCNEXT; /* Enable the CRC transmission*/
1065  0000 e601          	ld	a,(1,x)
1066  0002 aa10          	or	a,#16
1067  0004 e701          	ld	(1,x),a
1068                     ; 210 }
1071  0006 81            	ret	
1120                     ; 219 void SPI_CalculateCRCCmd(SPI_TypeDef* SPIx, FunctionalState NewState)
1120                     ; 220 {
1121                     .text:	section	.text,new
1122  0000               _SPI_CalculateCRCCmd:
1124  0000 89            	pushw	x
1125       00000000      OFST:	set	0
1128                     ; 222   assert_param(IS_FUNCTIONAL_STATE(NewState));
1130                     ; 225   SPI_Cmd(SPI1, DISABLE);
1132  0001 4b00          	push	#0
1133  0003 ae5200        	ldw	x,#20992
1134  0006 cd0000        	call	_SPI_Cmd
1136  0009 84            	pop	a
1137                     ; 227   if (NewState != DISABLE)
1139  000a 7b05          	ld	a,(OFST+5,sp)
1140  000c 2708          	jreq	L545
1141                     ; 229     SPIx->CR2 |= SPI_CR2_CRCEN; /* Enable the CRC calculation*/
1143  000e 1e01          	ldw	x,(OFST+1,sp)
1144  0010 e601          	ld	a,(1,x)
1145  0012 aa20          	or	a,#32
1147  0014 2006          	jra	L745
1148  0016               L545:
1149                     ; 233     SPIx->CR2 &= (uint8_t)(~SPI_CR2_CRCEN); /* Disable the CRC calculation*/
1151  0016 1e01          	ldw	x,(OFST+1,sp)
1152  0018 e601          	ld	a,(1,x)
1153  001a a4df          	and	a,#223
1154  001c               L745:
1155  001c e701          	ld	(1,x),a
1156                     ; 235 }
1159  001e 85            	popw	x
1160  001f 81            	ret	
1234                     ; 243 uint8_t SPI_GetCRC(SPI_TypeDef* SPIx, SPI_CRC_TypeDef SPI_CRC)
1234                     ; 244 {
1235                     .text:	section	.text,new
1236  0000               _SPI_GetCRC:
1238  0000 89            	pushw	x
1239  0001 88            	push	a
1240       00000001      OFST:	set	1
1243                     ; 245   uint8_t crcreg = 0;
1245                     ; 248   assert_param(IS_SPI_CRC(SPI_CRC));
1247                     ; 250   if (SPI_CRC != SPI_CRC_RX)
1249  0002 7b06          	ld	a,(OFST+5,sp)
1250  0004 2704          	jreq	L706
1251                     ; 252     crcreg = SPIx->TXCRCR;  /* Get the Tx CRC register*/
1253  0006 e607          	ld	a,(7,x)
1255  0008 2004          	jra	L116
1256  000a               L706:
1257                     ; 256     crcreg = SPIx->RXCRCR; /* Get the Rx CRC register*/
1259  000a 1e02          	ldw	x,(OFST+1,sp)
1260  000c e606          	ld	a,(6,x)
1261  000e               L116:
1262                     ; 260   return crcreg;
1266  000e 5b03          	addw	sp,#3
1267  0010 81            	ret	
1306                     ; 268 void SPI_ResetCRC(SPI_TypeDef* SPIx)
1306                     ; 269 {
1307                     .text:	section	.text,new
1308  0000               _SPI_ResetCRC:
1310  0000 89            	pushw	x
1311       00000000      OFST:	set	0
1314                     ; 272   SPI_CalculateCRCCmd(SPIx, ENABLE);
1316  0001 4b01          	push	#1
1317  0003 cd0000        	call	_SPI_CalculateCRCCmd
1319  0006 84            	pop	a
1320                     ; 275   SPI_Cmd(SPIx, ENABLE);
1322  0007 4b01          	push	#1
1323  0009 1e02          	ldw	x,(OFST+2,sp)
1324  000b cd0000        	call	_SPI_Cmd
1326  000e 84            	pop	a
1327                     ; 276 }
1330  000f 85            	popw	x
1331  0010 81            	ret	
1369                     ; 283 uint8_t SPI_GetCRCPolynomial(SPI_TypeDef* SPIx)
1369                     ; 284 {
1370                     .text:	section	.text,new
1371  0000               _SPI_GetCRCPolynomial:
1375                     ; 285   return SPIx->CRCPR; /* Return the CRC polynomial register */
1377  0000 e605          	ld	a,(5,x)
1380  0002 81            	ret	
1448                     ; 294 void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, SPI_Direction_TypeDef SPI_Direction)
1448                     ; 295 {
1449                     .text:	section	.text,new
1450  0000               _SPI_BiDirectionalLineConfig:
1452  0000 89            	pushw	x
1453       00000000      OFST:	set	0
1456                     ; 297   assert_param(IS_SPI_DIRECTION(SPI_Direction));
1458                     ; 299   if (SPI_Direction != SPI_Direction_Rx)
1460  0001 7b05          	ld	a,(OFST+5,sp)
1461  0003 2706          	jreq	L707
1462                     ; 301     SPIx->CR2 |= SPI_CR2_BDOE; /* Set the Tx only mode*/
1464  0005 e601          	ld	a,(1,x)
1465  0007 aa40          	or	a,#64
1467  0009 2006          	jra	L117
1468  000b               L707:
1469                     ; 305     SPIx->CR2 &= (uint8_t)(~SPI_CR2_BDOE); /* Set the Rx only mode*/
1471  000b 1e01          	ldw	x,(OFST+1,sp)
1472  000d e601          	ld	a,(1,x)
1473  000f a4bf          	and	a,#191
1474  0011               L117:
1475  0011 e701          	ld	(1,x),a
1476                     ; 307 }
1479  0013 85            	popw	x
1480  0014 81            	ret	
1557                     ; 317 void SPI_DMACmd(SPI_TypeDef* SPIx, SPI_DMAReq_TypeDef SPI_DMAReq, FunctionalState NewState)
1557                     ; 318 {
1558                     .text:	section	.text,new
1559  0000               _SPI_DMACmd:
1561  0000 89            	pushw	x
1562       00000000      OFST:	set	0
1565                     ; 320   assert_param(IS_FUNCTIONAL_STATE(NewState));
1567                     ; 321   assert_param(IS_SPI_DMAREQ(SPI_DMAReq));
1569                     ; 323   if (NewState != DISABLE)
1571  0001 7b06          	ld	a,(OFST+6,sp)
1572  0003 2706          	jreq	L357
1573                     ; 326     SPIx->CR3 |= (uint8_t) SPI_DMAReq;
1575  0005 e602          	ld	a,(2,x)
1576  0007 1a05          	or	a,(OFST+5,sp)
1578  0009 2007          	jra	L557
1579  000b               L357:
1580                     ; 331     SPIx->CR3 &= (uint8_t)~SPI_DMAReq;
1582  000b 1e01          	ldw	x,(OFST+1,sp)
1583  000d 7b05          	ld	a,(OFST+5,sp)
1584  000f 43            	cpl	a
1585  0010 e402          	and	a,(2,x)
1586  0012               L557:
1587  0012 e702          	ld	(2,x),a
1588                     ; 333 }
1591  0014 85            	popw	x
1592  0015 81            	ret	
1725                     ; 343 FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
1725                     ; 344 {
1726                     .text:	section	.text,new
1727  0000               _SPI_GetFlagStatus:
1729  0000 89            	pushw	x
1730  0001 88            	push	a
1731       00000001      OFST:	set	1
1734                     ; 345   FlagStatus status = RESET;
1736                     ; 347   assert_param(IS_SPI_FLAG(SPI_FLAG));
1738                     ; 350   if ((SPIx->SR & (uint8_t)SPI_FLAG) != (uint8_t)RESET)
1740  0002 e603          	ld	a,(3,x)
1741  0004 1506          	bcp	a,(OFST+5,sp)
1742  0006 2704          	jreq	L1401
1743                     ; 352     status = SET; /* SPI_FLAG is set */
1745  0008 a601          	ld	a,#1
1747  000a 2001          	jra	L3401
1748  000c               L1401:
1749                     ; 356     status = RESET; /* SPI_FLAG is reset*/
1751  000c 4f            	clr	a
1752  000d               L3401:
1753                     ; 360   return status;
1757  000d 5b03          	addw	sp,#3
1758  000f 81            	ret	
1805                     ; 379 void SPI_ClearFlag(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
1805                     ; 380 {
1806                     .text:	section	.text,new
1807  0000               _SPI_ClearFlag:
1809  0000 89            	pushw	x
1810       00000000      OFST:	set	0
1813                     ; 381   assert_param(IS_SPI_CLEAR_FLAG(SPI_FLAG));
1815                     ; 383   SPIx->SR = (uint8_t)(~SPI_FLAG);
1817  0001 7b05          	ld	a,(OFST+5,sp)
1818  0003 1e01          	ldw	x,(OFST+1,sp)
1819  0005 43            	cpl	a
1820  0006 e703          	ld	(3,x),a
1821                     ; 384 }
1824  0008 85            	popw	x
1825  0009 81            	ret	
1913                     ; 400 ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT)
1913                     ; 401 {
1914                     .text:	section	.text,new
1915  0000               _SPI_GetITStatus:
1917  0000 89            	pushw	x
1918  0001 5203          	subw	sp,#3
1919       00000003      OFST:	set	3
1922                     ; 402   ITStatus pendingbitstatus = RESET;
1924                     ; 403   uint8_t itpos = 0;
1926                     ; 404   uint8_t itmask1 = 0;
1928                     ; 405   uint8_t itmask2 = 0;
1930                     ; 406   __IO uint8_t enablestatus = 0;
1932  0003 0f02          	clr	(OFST-1,sp)
1933                     ; 407   assert_param(IS_SPI_GET_IT(SPI_IT));
1935                     ; 409   itpos = (uint8_t)((uint8_t)1 << ((uint8_t)SPI_IT & (uint8_t)0x0F));
1937  0005 7b08          	ld	a,(OFST+5,sp)
1938  0007 a40f          	and	a,#15
1939  0009 5f            	clrw	x
1940  000a 97            	ld	xl,a
1941  000b a601          	ld	a,#1
1942  000d 5d            	tnzw	x
1943  000e 2704          	jreq	L06
1944  0010               L26:
1945  0010 48            	sll	a
1946  0011 5a            	decw	x
1947  0012 26fc          	jrne	L26
1948  0014               L06:
1949  0014 6b01          	ld	(OFST-2,sp),a
1950                     ; 412   itmask1 = (uint8_t)((uint8_t)SPI_IT >> (uint8_t)4);
1952  0016 7b08          	ld	a,(OFST+5,sp)
1953  0018 4e            	swap	a
1954  0019 a40f          	and	a,#15
1955  001b 6b03          	ld	(OFST+0,sp),a
1956                     ; 414   itmask2 = (uint8_t)((uint8_t)1 << itmask1);
1958  001d 5f            	clrw	x
1959  001e 97            	ld	xl,a
1960  001f a601          	ld	a,#1
1961  0021 5d            	tnzw	x
1962  0022 2704          	jreq	L46
1963  0024               L66:
1964  0024 48            	sll	a
1965  0025 5a            	decw	x
1966  0026 26fc          	jrne	L66
1967  0028               L46:
1968  0028 6b03          	ld	(OFST+0,sp),a
1969                     ; 416   enablestatus = (uint8_t)((uint8_t)SPIx->SR & itmask2);
1971  002a 1e04          	ldw	x,(OFST+1,sp)
1972  002c e603          	ld	a,(3,x)
1973  002e 1403          	and	a,(OFST+0,sp)
1974  0030 6b02          	ld	(OFST-1,sp),a
1975                     ; 418   if (((SPIx->CR3 & itpos) != RESET) && enablestatus)
1977  0032 e602          	ld	a,(2,x)
1978  0034 1501          	bcp	a,(OFST-2,sp)
1979  0036 2708          	jreq	L3311
1981  0038 0d02          	tnz	(OFST-1,sp)
1982  003a 2704          	jreq	L3311
1983                     ; 421     pendingbitstatus = SET;
1985  003c a601          	ld	a,#1
1987  003e 2001          	jra	L5311
1988  0040               L3311:
1989                     ; 426     pendingbitstatus = RESET;
1991  0040 4f            	clr	a
1992  0041               L5311:
1993                     ; 429   return  pendingbitstatus;
1997  0041 5b05          	addw	sp,#5
1998  0043 81            	ret	
2053                     ; 448 void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT)
2053                     ; 449 {
2054                     .text:	section	.text,new
2055  0000               _SPI_ClearITPendingBit:
2057  0000 89            	pushw	x
2058  0001 88            	push	a
2059       00000001      OFST:	set	1
2062                     ; 450   uint8_t itpos = 0;
2064                     ; 451   assert_param(IS_SPI_CLEAR_IT(SPI_IT));
2066                     ; 456   itpos = (uint8_t)((uint8_t)1 << (((uint8_t)SPI_IT & (uint8_t)0xF0) >> 4));
2068  0002 7b06          	ld	a,(OFST+5,sp)
2069  0004 4e            	swap	a
2070  0005 a40f          	and	a,#15
2071  0007 5f            	clrw	x
2072  0008 97            	ld	xl,a
2073  0009 a601          	ld	a,#1
2074  000b 5d            	tnzw	x
2075  000c 2704          	jreq	L27
2076  000e               L47:
2077  000e 48            	sll	a
2078  000f 5a            	decw	x
2079  0010 26fc          	jrne	L47
2080  0012               L27:
2081  0012 6b01          	ld	(OFST+0,sp),a
2082                     ; 458   SPIx->SR = (uint8_t)(~itpos);
2084  0014 1e02          	ldw	x,(OFST+1,sp)
2085  0016 43            	cpl	a
2086  0017 e703          	ld	(3,x),a
2087                     ; 460 }
2090  0019 5b03          	addw	sp,#3
2091  001b 81            	ret	
2104                     	xdef	_SPI_ClearITPendingBit
2105                     	xdef	_SPI_GetITStatus
2106                     	xdef	_SPI_ClearFlag
2107                     	xdef	_SPI_GetFlagStatus
2108                     	xdef	_SPI_DMACmd
2109                     	xdef	_SPI_BiDirectionalLineConfig
2110                     	xdef	_SPI_GetCRCPolynomial
2111                     	xdef	_SPI_ResetCRC
2112                     	xdef	_SPI_GetCRC
2113                     	xdef	_SPI_CalculateCRCCmd
2114                     	xdef	_SPI_TransmitCRC
2115                     	xdef	_SPI_NSSInternalSoftwareCmd
2116                     	xdef	_SPI_ReceiveData
2117                     	xdef	_SPI_SendData
2118                     	xdef	_SPI_ITConfig
2119                     	xdef	_SPI_Cmd
2120                     	xdef	_SPI_Init
2121                     	xdef	_SPI_DeInit
2140                     	end
