#ifndef _GLOBDEF_H
#define _GLOBDEF_H


#define F_CPU 16000000L //16MHz

//Joystick buttons to control calibration (on PCB demoboard)
#define JOY_SEL   (!(GPIOE->IDR & GPIO_Pin_2)) //joystick select button 
#define JOY_LEFT  (!(GPIOE->IDR & GPIO_Pin_1)) //joystick left move button 
#define JOY_RIGHT (!(GPIOD->IDR & GPIO_Pin_5)) //joystick right move button 
#define JOY_UP    (!(GPIOD->IDR & GPIO_Pin_7)) //joystick increase value button 
#define JOY_DOWN  (!(GPIOD->IDR & GPIO_Pin_4)) //joystick decrease value button 
//button to finish calibration (KEY button on PCB demoboard)
#define BUTTON_LOW (!(GPIOC->IDR & GPIO_Pin_1))

#endif //_GLOBDEF_H